#!/bin/bash
PID=$$
FIFO=/tmp/FIFO${PID}
mkfifo $FIFO
# Déclaration des variables
IFS='
'
tmpdir=$(mktemp -d)
confdir="$HOME/.compteur_series"


# déclaration des fonctions
# Fonction de lecture d'une série déja configurée 
LECTURE () {
while true ; do
	if [ ! -d "$tmpdir" ] ; then
		break
	fi
	num_ep=$(($(tail -1 $dossier/.liste_ep) + 1))
	if [ "$(head -$(($num_ep)) $dossier/.liste_ep | tail -1)" = "###FIN###" ] ; then
		action=$(glade2script.py -g ./fin_episodes.compteur_series.glade)
		eval "$action"
		if [ "$EXIT" = "no" ] ; then
			kill -9 "$totem_pid"
			break
		else
			nouveaux_episodes
		fi	
	fi
	totem "$dossier/$(head -$(($num_ep)) $dossier/.liste_ep | tail -1)" &
	echo $(($num_ep)) >>$dossier/.liste_ep
	notify-send "$(head -$(($num_ep)) $dossier/.liste_ep | tail -1)"
	zenity --notification --window-icon="/home/$USER/scripts/icones/tv.png" --text="Cliquez ici pour lancer la lecture de l'épisode suivant"
done
}

# Fonction gérant la lecture des épisode et l'arret automatique du script lorsque l'utilisateur le demande
BOUCLE () {
totem &
sleep 2
totem_pid=$!
LECTURE &
wait $totem_pid
rm -rf "$tmpdir"
kill -9 $(ps aux | grep -v grep | grep "zenity --notification --window-icon=/home/$USER/scripts/icones/tv.png --text=Cliquez ici pour lancer la lecture de l'épisode suivant" | tr -s ' ' | cut -d" " -f2)

exit 0
}

# Fonction de lecture du premier épisode de la série
SAVE_AND_PLAY () {
echo 0 >>$dossier/.liste_ep
BOUCLE
}

# Fonction d'ajout d'une nouvelle série
nouvelle_serie () {
while true ; do
	fenetre_selection_serie=$(glade2script.py -g ./add_window.compteur_series.glade -r '_dossier_serie.get_filename,_nom_serie.get_text')
	eval "$fenetre_selection_serie"
	if [ "$EXIT" = "no" ] ; then
		exit 1
	elif [ "$_nom_serie_get_text" = "" ] ; then
		zenity --error --text="Aucun nom de série choisi. Veuillez en choisir un."
	elif cat $confdir/liste_serie | cut -d"|" -f1 | grep "$_nom_serie_get_text" ; then
		zenity --error --text="Le nom de série \"$_nom_serie_get_text\" existe déja. Veuillez en choisir un autre."
	else
		break
	fi
done	
dossier="$_dossier_serie_get_filename"
for i in $(ls -U $dossier | grep -v "\.nfo"$ | grep -v "\.txt"$ | grep -v "\.db"$) ; do
	echo "$i|normal" >>treeview_ep_trouves.data
done
echo "|normal">treeview_ep_ranges.data
fenetre_tri_episodes=$(glade2script.py -g ./sort_window.compteur_series.glade -r 'treeview_ep_trouves,treeview_ep_ranges' -t \
"@@treeview_ep_trouves@@episodes|FONT
$(cat treeview_ep_trouves.data)
@@treeview_ep_ranges@@episodes|FONT
$(cat treeview_ep_ranges.data)")

eval "$fenetre_tri_episodes"
if [ "$EXIT" = "yes" ] ; then
	echo "$_nom_serie_get_text|$_dossier_serie_get_filename|normal" >>$confdir/liste_serie
	cat treeview_ep_ranges.data | grep -v ^"|normal" | cut -d"|" -f1 >$dossier/.liste_ep
	echo "###FIN###" >>$dossier/.liste_ep
	rm -f treeview_ep_trouves.data treeview_ep_ranges.data
	SAVE_AND_PLAY
else
	rm -f treeview_ep_trouves.data treeview_ep_ranges.data
fi
}

# Fonction d'ajout de nouveaux épisodes à une séries existante
nouveaux_episodes () {
for i in $(cat $dossier/.liste_ep) ; do
	if [ "$i" = "###FIN###" ] ; then
		break
	else
		echo "$i" >>$dossier/.liste_ep.tmp
	fi
done

for i in $(cat $dossier/.liste_ep.tmp) ; do
	echo "$i|normal" >>treeview_ep_ranges.data
done

for i in $(ls -U $dossier | grep -v "\.nfo"$ | grep -v "\.txt"$ | grep -v "\.db"$) ; do
	if ! grep "$i" "$dossier/.liste_ep.tmp" ; then
		echo "$i|normal" >>treeview_ep_trouves.data
	fi
done

fenetre_tri_episodes=$(glade2script.py -g ./sort_window.compteur_series.glade -r 'treeview_ep_trouves,treeview_ep_ranges' -t \
"@@treeview_ep_trouves@@episodes|FONT
$(cat treeview_ep_trouves.data)
@@treeview_ep_ranges@@episodes|FONT
$(cat treeview_ep_ranges.data)")

eval "$fenetre_tri_episodes"

if [ "$EXIT" = "yes" ] ; then
	rm -f $dossier/.liste_ep $dossier/.liste_ep.tmp
	cat treeview_ep_ranges.data | grep -v ^"|normal" | cut -d"|" -f1 >>$dossier/.liste_ep
	echo "###FIN###" >>$dossier/.liste_ep
	echo $(($num_ep - 1)) >>$dossier/.liste_ep
	rm -f treeview_ep_trouves.data treeview_ep_ranges.data
else
	rm -f treeview_ep_trouves.data treeview_ep_ranges.data
fi
}

# Fonction menu principal
menu_principal () {
fenetre_principale=$(glade2script.py -g ./main_window.compteur_series.glade -r 'treeview_lire_serie' -t \
"@@treeview_lire_serie@@serie|HIDE|FONT
$(cat $confdir/liste_serie)")
eval "$fenetre_principale"
if [ "$EXIT" = "no" ] ; then
	exit 1
elif [ -n "$treeview_lire_serie" ] ; then
	dossier=$(echo "$treeview_lire_serie" | cut -d"|" -f2)
	BOUCLE
else
	nouvelle_serie
fi
}



# début du script

if [ ! -f $confdir/liste_serie ] ; then
	mkdir $confdir
	nouvelle_serie
else
	menu_principal
fi
 
